xmonad-contrib-0.13: Third party extensions for xmonad

Copyright | (C) 2007 Andrea Rossato
License | BSD3
Maintainer | andrea.rossato@unibz.it
Stability | unstable
Portability | unportable
Safe Haskell | None
Language | Haskell98

XMonad.Prompt.Shell

Contents

- Usage
  - Variations on shellPrompt
- Utility functions

Description

A shell prompt for XMonad

Synopsis

- data Shell = Shell
- shellPrompt :: XPConfig -> X ()
- prompt :: FilePath -> XPConfig -> X ()
- safePrompt :: FilePath -> XPConfig -> X ()
- unsafePrompt :: FilePath -> XPConfig -> X ()
- getCommands :: IO [String]
- getBrowser :: IO String
- getEditor :: IO String
- getShellCompl :: [String] -> Predicate -> String -> IO [String]
- split :: Eq a => a -> [a] -> [[a]]

# Usage

1. In your `~/.xmonad/xmonad.hs`:

    import XMonad.Prompt
    import XMonad.Prompt.Shell

1. In your keybindings add something like:

      , ((modm .|. controlMask, xK_x), shellPrompt def)

For detailed instruction on editing the key binding see XMonad.Doc.Extending.

data Shell Source #

Constructors

Shell |

Instances

XPrompt Shell Source # |
Methods showXPrompt :: Shell -> String Source # nextCompletion :: Shell -> String -> [String] -> String Source # commandToComplete :: Shell -> String -> String Source # completionToCommand :: Shell -> String -> String Source # completionFunction :: Shell -> ComplFunction Source # modeAction :: Shell -> String -> String -> X () Source #

shellPrompt :: XPConfig -> X () Source #

## Variations on shellPrompt

See safe and unsafeSpawn in XMonad.Util.Run. prompt is an alias for unsafePrompt; safePrompt and unsafePrompt work on the same principles, but will use XPrompt to interactively query the user for input; the appearance is set by passing an XPConfig as the second argument. The first argument is the program to be run with the interactive input. You would use these like this:

        , ((modm,               xK_b), safePrompt "firefox" greenXPConfig)
        , ((modm .|. shiftMask, xK_c), prompt ("xterm" ++ " -e") greenXPConfig)

Note that you want to use safePrompt for Firefox input, as Firefox wants URLs, and unsafePrompt for the XTerm example because this allows you to easily start a terminal executing an arbitrary command, like `top`.

prompt :: FilePath -> XPConfig -> X () Source #

safePrompt :: FilePath -> XPConfig -> X () Source #

unsafePrompt :: FilePath -> XPConfig -> X () Source #

# Utility functions

getCommands :: IO [String] Source #

getBrowser :: IO String Source #

Ask the shell what browser the user likes. If the user hasn't defined any $BROWSER, defaults to returning "firefox", since that seems to be the most common X web browser. Note that if you don't specify a GUI browser but a textual one, that'll be a problem as `getBrowser` will be called by functions expecting to be able to just execute the string or pass it to a shell; so in that case, define $BROWSER as something like "xterm -e elinks" or as the name of a shell script doing much the same thing.

getEditor :: IO String Source #

Like `getBrowser`, but should be of a text editor. This gets the $EDITOR variable, defaulting to "emacs".

getShellCompl :: [String] -> Predicate -> String -> IO [String] Source #

split :: Eq a => a -> [a] -> [[a]] Source #